#ifndef INCLUDED__B_F_D_V_P__SIMPLE__G_L_U_T__H
#define INCLUDED__B_F_D_V_P__SIMPLE__G_L_U_T__H

/* FILE:        BFDVPsimpleGLUT.h
 * DATE:        5/8/2014
 * AUTHOR:      Jeremy Greene
 * COMPANY:     BitFlow, Inc.
 * COPYRIGHT:   Copyright (C) 2014, BitFlow, Inc.
 * DESCRIPTION: A very simple interface for displaying a single grayscale image using FreeGLUT.
 */

#include <cuda.h>

// Enter the GLUT main-loop with the given settings. This will return when the user closes the display
// window. Only on thread should call this method at any given time.
void enterBFDVPsimpleGLUT                   ( int argc, char *argv[]
                                            , const unsigned int width
                                            , const unsigned int height
                                            , const unsigned int bitdepth
                                            , const bool fullScreen = false);

// Exit the GLUT main-loop on demand, closing any windows.
void exitBFDVPsimpleGLUT                    (void);

// Setup a callback function to be called whenever an ASCII keyboard key is pressed. If this function
// returns true, the display will ignore the keypress internally. If false, the keypress may invoke
// some standard internal behavior.
typedef bool (*BFDVPsimpleGLUTkeyCallback) (char key);

void setBFDVPsimpleGLUTkeyCallback          (BFDVPsimpleGLUTkeyCallback callback);

// Pass a buffer to BFDVPsimpleGLUT for display (we target 60Hz display; some buffers may be dropped).
// A prior call to enterBFDVPsimpleGLUT should still be running.
void setMainBFDVPsimpleGLUT                 (const CUdeviceptr displayBuf);

// Set the overlay text.
void setBFDVPsimpleGLUToverlayText          (const char *const text);

// Return the estimated rate in Hz at which frames are being displayed.
double getBFDVPsimpleGLUTdisplayRateAverage (void);

#endif // INCLUDED__B_F_D_V_P__SIMPLE__G_L_U_T__H
