#include "QuadrantChannelGain.h"

#include <algorithm>
#include <cmath>

enum : ChannelGain8
{
    ExpGainMin = 0,
    ExpGainMax = (ChannelGain8)~ExpGainMin
};

extern "C" double clampLinGain (const double linGain)
{
    return std::min(1., std::max(0., linGain));
}

extern "C" ChannelGain8 clampExpGain (const double expGain)
{
    return (ChannelGain8)std::min<double>(ExpGainMax, std::max<double>(ExpGainMin, expGain));
}

extern "C" ChannelGain8 lin2expGain8 (const double linGain)
{
    const double expGain = pow(256., 2. * linGain) - 1.;
    return clampExpGain(expGain);
}
extern "C" double exp2linGain8 (const ChannelGain8 expGain)
{
    const double linGain = log(1. + (double)expGain) / log(256.) / 2.;
    return clampLinGain(linGain);
}
extern "C" void fillQuadGains8 (QuadrantGains8 *const qg, const double lgY0X0, const double lgY0X1, const double lgY1X0, const double lgY1X1)
{
    qg->y[0].x[0] = lin2expGain8(lgY0X1);
    qg->y[0].x[1] = lin2expGain8(lgY0X0);
    qg->y[1].x[0] = lin2expGain8(lgY1X1);
    qg->y[1].x[1] = lin2expGain8(lgY1X0);
}
